::AbilitySapperAttachment <- class extends BaseAbility
{
    //Custom character definition
    sapperModels = [
        [933, "models/buildables/p2rec_placed.mdl"],
        [810, "models/buildables/sd_sapper_placed.mdl"],
        [1080, "models/buildables/sapper_xmas_placed.mdl"],
        [1102, "models/buildables/breadmonster_sapper_placed.mdl"],
        [735, "models/buildables/sapper_placed.mdl"],
    ]
    sapperBlueprintModels = [
        [933, "models/buildables/p2rec_placement.mdl"],
        [810, "models/buildables/sd_sapper_placement.mdl"],
        [1080, "models/buildables/sapper_xmas_placement.mdl"],
        [1102, "models/buildables/breadmonster_sapper_placement.mdl"],
        [735, "models/buildables/sapper_placement.mdl"],
    ]
    //Dynamic data
    sapper_wearable_ent = null;

    function Precache()
    {
        foreach(entry in sapperModels)
            PrecacheModel(entry[1]);
    }

    function TryApplyBlueprint()
    {
    }

    function CanApplySapper()
    {
        return !HasSapper();
    }

    function HasSapper()
    {
        return sapper_wearable_ent && sapper_wearable_ent.IsValid();
    }

    function TryApplySapper(spyPlayer, sapperWeapon)
    {
        if (!CanApplySapper())
            return;

        sapper_wearable_ent = player.CreateWorldModel(GetSapperModel(sapperWeapon));
        charScript.EmitSoundBankSimple("sapper_placed_sfx");
        charScript.EmitSoundBankSimple("sapper_sfx");

        if (GetItemId(sapperWeapon) == 933)  //Ap-Sap
            charScript.EmitSoundBankSimple("sapper_placed_apsap");

        player.AddCondEx(TF_COND_SAPPED, 4, spyPlayer);

        RunWithDelay(4, function()
        {
            sapper_wearable_ent = KillIfValid(sapper_wearable_ent);
            charScript.EmitSoundBankSimple("sapper_removed_sfx");
        });
        AddTimer(0.1, TickSapper, Time() + 4)
    }

    function TickSapper(expiration)
    {
        if (Time() > expiration)
            return TIMER_DELETE;
        player.AddCustomAttribute("move speed penalty", 0.75, 0.2);
    }

    function GetSapperModel(weapon)
    {
        local id = GetItemId(weapon);
        foreach (entry in sapperModels)
            if (entry[0] == id)
                return entry[1];
        return "models/buildables/sapper_placed.mdl";
    }

    function GetBlueprintModel(weapon)
    {
        local id = GetItemId(weapon);
        foreach (entry in sapperBlueprintModels)
            if (entry[0] == id)
                return entry[1];
        return "models/buildables/sapper_placement.mdl";
    }
}