::VIPShared <- class extends CustomCharacter
{
    deleteItems = true;
    mute = true;
    keepAfterDeath = false;
    keepAfterClassChange = false;

    lastNag = 0;
    playersOnCountCounter = 0;

    function ApplyCharacter()
    {
        base.ApplyCharacter();
        local compassController = CompassController(player);
        local glowController = GlowController(player);
        OnSelfEvent("vip_gone", glowController.DestroyGlowController.bindenv(glowController));
        OnSelfEvent("vip_gone", compassController.DestroyCompassController.bindenv(compassController));

        local myTeam = player.GetTeam();
        local teamPointOrigins = [];
        for (local point; point = Entities.FindByClassname(point, "team_control_point");)
            if (myTeam != point.GetTeam())
                teamPointOrigins.push(point.GetOrigin());

        local self = player;

        AddTimer(3, function()
        {
            local pointPos = null;
            foreach (pointOrigin in teamPointOrigins)
            {
                playersOnCountCounter = 0;
                foreach (player in GetAlivePlayers())
                {
                    if (player != self && player.GetTeam() == myTeam && (player.GetOrigin() - pointOrigin).Length2D() < 400)
                        playersOnCountCounter++;
                }
                if (playersOnCountCounter >= 2)
                    pointPos = pointOrigin;
            }

            if (playersOnCountCounter >= 2 && Time() - lastNag > 10 && pointPos && self && (self.GetOrigin() - pointPos).Length2D() > 600)
            {
                lastNag = Time();
                SendGlobalGameEvent("show_annotation",
                {
                    worldPosX = pointPos.x,
                    worldPosY = pointPos.y,
                    worldPosZ = pointPos.z,
                    id = 123,
                    text = "Your team contests Point!",
                    lifetime = 10,
                    visibilityBitfield = 1 << self.entindex(),
                    play_sound = "ui/hint.wav"
                });
            }
        });

        /*player.GetScriptScope().PreventDroppedWeapons <-  function()
        {
            printl("tick a")
            for (local droppedWeapon = null; droppedWeapon = FindByClassname(droppedWeapon, "tf_dropped_weapon");)
                droppedWeapon.AddEFlags(EFL_KILLME);
            return -1;
        };
        AddThinkToEnt(player, "PreventDroppedWeapons");

        test = SpawnEntityFromTable("point_template", {});
        test.ValidateScriptScope();
        test.GetScriptScope().PreventDroppedWeapons <- function()
        {
            printl("tick b")
            for (local droppedWeapon = null; droppedWeapon = FindByClassname(droppedWeapon, "tf_dropped_weapon");)
            {
                printl("droppedWeapon="+droppedWeapon)
                droppedWeapon.RemoveEFlags(EFL_KILLME);
            }
            return -1;
        };
        AddThinkToEnt(test, "PreventDroppedWeapons");*/
    }

    /*function OnCleanup()
    {
        base.OnCleanup();
        printl("OnCleanup");
        AddThinkToEnt(player, null);
        KillIfValid(test);
        SetPropString(player, "m_iszScriptThinkFunction", "");
    }*/

    debuffs = [ //todo move to good place
        TF_COND_BURNING,
        TF_COND_URINE,
        TF_COND_MAD_MILK,
        TF_COND_BLEEDING,
        TF_COND_ENERGY_BUFF,
        TF_COND_CANNOT_SWITCH_FROM_MELEE,
        TF_COND_PHASE,
        TF_COND_PARACHUTE_DEPLOYED,
        TF_COND_PLAGUE
    ]

    function OnRegenerate(fakeRegenTrigger)
    {
        primary.SetClip1(typewriter.clip);
        secondary.SetClip1(1);
        SetPropIntArray(player, "m_iAmmo", typewriter.maxAmmo, primary.GetPrimaryAmmoType());
        SetPropIntArray(player, "m_iAmmo", 1, secondary.GetPrimaryAmmoType());

        player.SetHealth(player.GetMaxHealth());

        foreach (debuff in debuffs)
            player.RemoveCond(debuff);

        return 1;
    }
}